/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-topic-proxy-0.1.0-1precise-20150328-0735/srv/PublishMessage.srv
 *
 */


#ifndef TOPIC_PROXY_MESSAGE_PUBLISHMESSAGEREQUEST_H
#define TOPIC_PROXY_MESSAGE_PUBLISHMESSAGEREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <topic_proxy/MessageInstance.h>

namespace topic_proxy
{
template <class ContainerAllocator>
struct PublishMessageRequest_
{
  typedef PublishMessageRequest_<ContainerAllocator> Type;

  PublishMessageRequest_()
    : message()
    , latch(false)  {
    }
  PublishMessageRequest_(const ContainerAllocator& _alloc)
    : message(_alloc)
    , latch(false)  {
    }



   typedef  ::topic_proxy::MessageInstance_<ContainerAllocator>  _message_type;
  _message_type message;

   typedef uint8_t _latch_type;
  _latch_type latch;




  typedef boost::shared_ptr< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PublishMessageRequest_

typedef ::topic_proxy::PublishMessageRequest_<std::allocator<void> > PublishMessageRequest;

typedef boost::shared_ptr< ::topic_proxy::PublishMessageRequest > PublishMessageRequestPtr;
typedef boost::shared_ptr< ::topic_proxy::PublishMessageRequest const> PublishMessageRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::topic_proxy::PublishMessageRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace topic_proxy

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'topic_proxy': ['/tmp/buildd/ros-hydro-topic-proxy-0.1.0-1precise-20150328-0735/msg'], 'blob': ['/opt/ros/hydro/share/blob/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "0bfb78644634f93633d70b6a4a05176c";
  }

  static const char* value(const ::topic_proxy::PublishMessageRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x0bfb78644634f936ULL;
  static const uint64_t static_value2 = 0x33d70b6a4a05176cULL;
};

template<class ContainerAllocator>
struct DataType< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "topic_proxy/PublishMessageRequest";
  }

  static const char* value(const ::topic_proxy::PublishMessageRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
MessageInstance message\n\
bool latch\n\
\n\
================================================================================\n\
MSG: topic_proxy/MessageInstance\n\
string topic\n\
string md5sum\n\
string type\n\
string message_definition\n\
blob/Blob blob\n\
\n\
================================================================================\n\
MSG: blob/Blob\n\
bool compressed\n\
uint8[] data\n\
";
  }

  static const char* value(const ::topic_proxy::PublishMessageRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.message);
      stream.next(m.latch);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PublishMessageRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::topic_proxy::PublishMessageRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::topic_proxy::PublishMessageRequest_<ContainerAllocator>& v)
  {
    s << indent << "message: ";
    s << std::endl;
    Printer< ::topic_proxy::MessageInstance_<ContainerAllocator> >::stream(s, indent + "  ", v.message);
    s << indent << "latch: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.latch);
  }
};

} // namespace message_operations
} // namespace ros

#endif // TOPIC_PROXY_MESSAGE_PUBLISHMESSAGEREQUEST_H
